ImportC "winmm.lib"
EndImport

Import "StSoundLibrary_static.lib"
  ymMusicCreate()
  ymMusicLoadMemory(*p,*a,len.l)
  ymMusicSetLoopMode(*p,f.l)
  ymMusicSoundServerStart(*p)
  ymMusicPlay(*p)
  ymMusicSoundServerStop(*p)
  ymMusicDestroy(*p)
EndImport

; rasters
Dim co.l(548*2)
Restore cols
For i=0 To 547
  Read.l co(i)
  co(548*2-1-i)=co(i)
Next i
;
UsePNGImageDecoder()
CatchImage(4,?ball);62x62

For i=0 To 3
  CreateImage(i,640,480,32)
  StartDrawing(ImageOutput(i))
  DrawingMode(#PB_2DDrawing_AllChannels)
  Box (0,0,640,480,RGBA(0,0,0,0))
  StopDrawing()
Next i


copo.l=0
imc.l=0
cx.l=0
cy.l=0

*p=ymMusicCreate()
ymMusicLoadMemory(*p,?mus,?mus_e-?mus)

ymMusicSetLoopMode(*p,1);, pMusic, TRUE
If ymMusicSoundServerStart(*p);, pMusic
  ymMusicPlay(*p)             ;, pMusic
Else
  MessageRequester("error", "oops with sound", #PB_MessageRequester_Ok)
  End
EndIf

If InitSprite() And OpenWindow(0,0,0,640,480,"YM powah",#PB_Window_SystemMenu|#PB_Window_ScreenCentered) And OpenWindowedScreen(WindowID(0),0,0,640,480,0,0,0) 
  Repeat 
    StartDrawing(ImageOutput(imc))
    
    y=Int(209+209*Sin(cy*#PI/128))
    x=Int(289+289*Cos(cx*#PI/128))
    
    DrawAlphaImage( ImageID(4),x,y )
    StopDrawing()
    
    cx=(cx+1)&255
    If cx=250:cx=0:EndIf
    
    cy=(cy+1)&255
    
    StartDrawing(ScreenOutput())
    
    ;draw raster
    cp.l=copo
    ;https://www.ninelizards.com/purebasic/purebasic%2006.htm
    DrawingMode(#PB_2DDrawing_AlphaChannel)
    For i=0 To 480
      If cp>548*2-1
        cp=0
      EndIf
      LineXY(0,i,640,i,co(cp))
      cp+1
    Next i
    
    copo+2
    If copo>548*2-1
      copo=0
    EndIf
    
    DrawingMode(#PB_2DDrawing_AllChannels)
    DrawAlphaImage(ImageID(imc),0,0)
    StopDrawing() 
    FlipBuffers()
    imc=(imc+1)&3
  Until WindowEvent()=#PB_Event_CloseWindow 
EndIf

ymMusicSoundServerStop(*p);, pMusic
ymMusicDestroy(*p)        ;, pMusic

DataSection
  ball:
  IncludeBinary "red_ball.png"
  ;IncludeBinary "emptyball.png"
  mus:
  IncludeBinary "150mph.ym"
  mus_e:
  cols:
  ;{
  Data.l 16711680
  Data.l 16711936
  Data.l 16712192
  Data.l 16712704
  Data.l 16713472
  Data.l 16714240
  Data.l 16714752
  Data.l 16715008
  Data.l 16716032
  Data.l 16716544
  Data.l 16716800
  Data.l 16717568
  Data.l 16718592
  Data.l 16718848
  Data.l 16719360
  Data.l 16720128
  Data.l 16720640
  Data.l 16721152
  Data.l 16721920
  Data.l 16722688
  Data.l 16722944
  Data.l 16723456
  Data.l 16724480
  Data.l 16724992
  Data.l 16725504
  Data.l 16726016
  Data.l 16726784
  Data.l 16727296
  Data.l 16727808
  Data.l 16728576
  Data.l 16729088
  Data.l 16729600
  Data.l 16730112
  Data.l 16731136
  Data.l 16731392
  Data.l 16731904
  Data.l 16732672
  Data.l 16733184
  Data.l 16733696
  Data.l 16734464
  Data.l 16735232
  Data.l 16735488
  Data.l 16736256
  Data.l 16736768
  Data.l 16737280
  Data.l 16737792
  Data.l 16738816
  Data.l 16739328
  Data.l 16739584
  Data.l 16740608
  Data.l 16741120
  Data.l 16741376
  Data.l 16742144
  Data.l 16742912
  Data.l 16743424
  Data.l 16743424
  Data.l 16744704
  Data.l 16745472
  Data.l 16745984
  Data.l 16746240
  Data.l 16747008
  Data.l 16747520
  Data.l 16748032
  Data.l 16748800
  Data.l 16749568
  Data.l 16750080
  Data.l 16750336
  Data.l 16751360
  Data.l 16751616
  Data.l 16752128
  Data.l 16753152
  Data.l 16753408
  Data.l 16753920
  Data.l 16754944
  Data.l 16755456
  Data.l 16755712
  Data.l 16756480
  Data.l 16757248
  Data.l 16757504
  Data.l 16758016
  Data.l 16759040
  Data.l 16759808
  Data.l 16760064
  Data.l 16760832
  Data.l 16761344
  Data.l 16761856
  Data.l 16762368
  Data.l 16763136
  Data.l 16763904
  Data.l 16764160
  Data.l 16764928
  Data.l 16765696
  Data.l 16766208
  Data.l 16766720
  Data.l 16767232
  Data.l 16768000
  Data.l 16768256
  Data.l 16769280
  Data.l 16769792
  Data.l 16770304
  Data.l 16770816
  Data.l 16771584
  Data.l 16772096
  Data.l 16772352
  Data.l 16773376
  Data.l 16773888
  Data.l 16774144
  Data.l 16775168
  Data.l 16775936
  Data.l 16776192
  Data.l 16711168
  Data.l 16580353
  Data.l 16383748
  Data.l 16252678
  Data.l 16121609
  Data.l 15859468
  Data.l 15728397
  Data.l 15662864
  Data.l 15466259
  Data.l 15269652
  Data.l 15138582
  Data.l 15007514
  Data.l 14810909
  Data.l 14679838
  Data.l 14614304
  Data.l 14352163
  Data.l 14155558
  Data.l 14090023
  Data.l 13958953
  Data.l 13696813
  Data.l 13631278
  Data.l 13500209
  Data.l 13303604
  Data.l 13106998
  Data.l 12975928
  Data.l 12844858
  Data.l 12648253
  Data.l 12648253
  Data.l 12582718
  Data.l 12320578
  Data.l 12189508
  Data.l 12058438
  Data.l 11927369
  Data.l 11730763
  Data.l 11534158
  Data.l 11534159
  Data.l 11272018
  Data.l 11140948
  Data.l 11009879
  Data.l 10878809
  Data.l 10682203
  Data.l 10485598
  Data.l 10420063
  Data.l 10223459
  Data.l 10026853
  Data.l 9895783
  Data.l 9764713
  Data.l 9568108
  Data.l 9437038
  Data.l 9371503
  Data.l 9174898
  Data.l 8912759
  Data.l 8847224
  Data.l 8716153
  Data.l 8585084
  Data.l 8454014
  Data.l 8257408
  Data.l 8060803
  Data.l 7864199
  Data.l 7798664
  Data.l 7667594
  Data.l 7405453
  Data.l 7339919
  Data.l 7208849
  Data.l 6946708
  Data.l 6881174
  Data.l 6750104
  Data.l 6553498
  Data.l 6291358
  Data.l 6291359
  Data.l 6094753
  Data.l 5898148
  Data.l 5767078
  Data.l 5636008
  Data.l 5504938
  Data.l 5242798
  Data.l 5177263
  Data.l 5046194
  Data.l 4784052
  Data.l 4652982
  Data.l 4587449
  Data.l 4390843
  Data.l 4194238
  Data.l 4128703
  Data.l 3932097
  Data.l 3735494
  Data.l 3604424
  Data.l 3538889
  Data.l 3276747
  Data.l 3145678
  Data.l 3080143
  Data.l 2883538
  Data.l 2621399
  Data.l 2555864
  Data.l 2424793
  Data.l 2228188
  Data.l 2097118
  Data.l 2031584
  Data.l 1769443
  Data.l 1638373
  Data.l 1507304
  Data.l 1376233
  Data.l 1114093
  Data.l 1048559
  Data.l 917488
  Data.l 655348
  Data.l 589813
  Data.l 458744
  Data.l 262138
  Data.l 131068
  Data.l 65278
  Data.l 130303
  Data.l 194815
  Data.l 259583
  Data.l 390399
  Data.l 455423
  Data.l 651263
  Data.l 651007
  Data.l 716031
  Data.l 846335
  Data.l 911615
  Data.l 976639
  Data.l 1041407
  Data.l 1237247
  Data.l 1236991
  Data.l 1367551
  Data.l 1497855
  Data.l 1563135
  Data.l 1627903
  Data.l 1758207
  Data.l 1823487
  Data.l 1823231
  Data.l 1953279
  Data.l 2018303
  Data.l 2083583
  Data.l 2148351
  Data.l 2344191
  Data.l 2475007
  Data.l 2474751
  Data.l 2604799
  Data.l 2669567
  Data.l 2800127
  Data.l 2865663
  Data.l 2995967
  Data.l 3060991
  Data.l 3060735
  Data.l 3190527
  Data.l 3255807
  Data.l 3386623
  Data.l 3451647
  Data.l 3581695
  Data.l 3646719
  Data.l 3711999
  Data.l 3776767
  Data.l 3841791
  Data.l 3972607
  Data.l 4037375
  Data.l 4233215
  Data.l 4232959
  Data.l 4363775
  Data.l 4493823
  Data.l 4558847
  Data.l 4623871
  Data.l 4688639
  Data.l 4819711
  Data.l 4950271
  Data.l 4949247
  Data.l 5014015
  Data.l 5079039
  Data.l 5078783
  Data.l 5275135
  Data.l 5470719
  Data.l 5470719
  Data.l 5600767
  Data.l 5665535
  Data.l 5730559
  Data.l 5795839
  Data.l 5926655
  Data.l 6056703
  Data.l 6056447
  Data.l 6187263
  Data.l 6251775
  Data.l 6382335
  Data.l 6512895
  Data.l 6577663
  Data.l 6707967
  Data.l 6642431
  Data.l 6773247
  Data.l 6837503
  Data.l 6968063
  Data.l 7033343
  Data.l 7163647
  Data.l 7228927
  Data.l 7293951
  Data.l 7424255
  Data.l 7489023
  Data.l 7619839
  Data.l 7685119
  Data.l 7815167
  Data.l 7880447
  Data.l 7945471
  Data.l 8009983
  Data.l 8074751
  Data.l 8205567
  Data.l 8271103
  Data.l 8466687
  Data.l 8466175
  Data.l 8531199
  Data.l 8596223
  Data.l 8726783
  Data.l 8791807
  Data.l 8856831
  Data.l 9052415
  Data.l 9052159
  Data.l 9117695
  Data.l 9247743
  Data.l 9312511
  Data.l 9508607
  Data.l 9508095
  Data.l 9573375
  Data.l 9507839
  Data.l 9376511
  Data.l 9311231
  Data.l 9245695
  Data.l 9179903
  Data.l 9114111
  Data.l 8983295
  Data.l 8917759
  Data.l 8721151
  Data.l 8655615
  Data.l 8524287
  Data.l 8524031
  Data.l 8458495
  Data.l 8262143
  Data.l 8262143
  Data.l 8196607
  Data.l 8065023
  Data.l 8065279
  Data.l 7868671
  Data.l 7737599
  Data.l 7737599
  Data.l 7606271
  Data.l 7540479
  Data.l 7475199
  Data.l 7344127
  Data.l 7344127
  Data.l 7213055
  Data.l 7081727
  Data.l 7081471
  Data.l 6950399
  Data.l 6688511
  Data.l 6688511
  Data.l 6753535
  Data.l 6557183
  Data.l 6491647
  Data.l 6426111
  Data.l 6295039
  Data.l 6229503
  Data.l 6163967
  Data.l 6163455
  Data.l 5967103
  Data.l 5901567
  Data.l 5770495
  Data.l 5639167
  Data.l 5573375
  Data.l 5508095
  Data.l 5442559
  Data.l 5311487
  Data.l 5245951
  Data.l 5114879
  Data.l 5048831
  Data.l 4983551
  Data.l 4918015
  Data.l 4852223
  Data.l 4720895
  Data.l 4655615
  Data.l 4524543
  Data.l 4459007
  Data.l 4327935
  Data.l 4327935
  Data.l 4196607
  Data.l 4065279
  Data.l 4065535
  Data.l 3934463
  Data.l 3737343
  Data.l 3672063
  Data.l 3672063
  Data.l 3540991
  Data.l 3409919
  Data.l 3409919
  Data.l 3344127
  Data.l 3278335
  Data.l 3147519
  Data.l 3147519
  Data.l 2950911
  Data.l 2885375
  Data.l 2754303
  Data.l 2622975
  Data.l 2557183
  Data.l 2491903
  Data.l 2491903
  Data.l 2229759
  Data.l 2294783
  Data.l 2229247
  Data.l 2098431
  Data.l 2032895
  Data.l 1967359
  Data.l 1967359
  Data.l 1770495
  Data.l 1704703
  Data.l 1573887
  Data.l 1508351
  Data.l 1442559
  Data.l 1376767
  Data.l 1311231
  Data.l 1180415
  Data.l 1114879
  Data.l 983807
  Data.l 918015
  Data.l 786687
  Data.l 721407
  Data.l 655871
  Data.l 524799
  Data.l 459263
  Data.l 393471
  Data.l 196863
  Data.l 196863
  Data.l 196863
  Data.l 131326
  Data.l 254
  Data.l 764
  Data.l 1273
  Data.l 2038
  Data.l 2548
  Data.l 3059
  Data.l 4079
  Data.l 4589
  Data.l 4843
  Data.l 5609
  Data.l 6374
  Data.l 6629
  Data.l 7138
  Data.l 8158
  Data.l 8668
  Data.l 8923
  Data.l 9688
  Data.l 10710
  Data.l 10708
  Data.l 11218
  Data.l 12494
  Data.l 12748
  Data.l 13003
  Data.l 14024
  Data.l 14789
  Data.l 15044
  Data.l 15554
  Data.l 16574
  Data.l 16828
  Data.l 17338
  Data.l 18103
  Data.l 18613
  Data.l 19124
  Data.l 19889
  Data.l 20909
  Data.l 20908
  Data.l 21418
  Data.l 22438
  Data.l 22948
  Data.l 23204
  Data.l 24225
  Data.l 24989
  Data.l 24988
  Data.l 25754
  Data.l 26774
  Data.l 27029
  Data.l 27283
  Data.l 28303
  Data.l 29069
  Data.l 29323
  Data.l 29833
  Data.l 30854
  Data.l 31109
  Data.l 31618
  Data.l 32129
  Data.l 32893
  Data.l 33403
  Data.l 34168
  Data.l 35189
  Data.l 35188
  Data.l 35699
  Data.l 36974
  Data.l 37228
  Data.l 37483
  Data.l 38248
  Data.l 39013
  Data.l 39268
  Data.l 40034
  Data.l 41054
  Data.l 41308
  Data.l 41563
  Data.l 42583
  Data.l 43093
  Data.l 43604
  Data.l 44114
  Data.l 45134
  Data.l 45388
  Data.l 45898
  Data.l 46919
  Data.l 47429
  Data.l 47684
  Data.l 48448
  Data.l 49469
  Data.l 49468
  Data.l 49978
  Data.l 51254
  Data.l 51509
  Data.l 51763
  Data.l 52784
  Data.l 53549
  Data.l 53547
  Data.l 54313
  Data.l 55334
  Data.l 55588
  Data.l 55843
  Data.l 57120
  Data.l 57629
  Data.l 57883
  Data.l 58393
  Data.l 59158
  Data.l 59668
  Data.l 60179
  Data.l 61199
  Data.l 61709
  Data.l 61963
  Data.l 62728
  Data.l 63493
  Data.l 63747
  Data.l 64257
  ;}
  
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 68
; FirstLine = 54
; Folding = +
; Executable = ympowah.exe